#ifndef EFL_GENERATED_ECORE_PARENT_HH
#define EFL_GENERATED_ECORE_PARENT_HH

#include <Eo.h>
#include <Eo.hh>

extern "C"
{
#include "ecore_parent.eo.h"
}


struct ecore_parent
      : efl::eo::base
{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit ecore_parent(Eo* eo)
      : efl::eo::base(eo)
   {}

   /// @brief Copy Constructor.
   ///
   ecore_parent(ecore_parent const& other)
      : efl::eo::base(eo_ref(other._eo_ptr()))
   {}

   ~ecore_parent() {}

   static Eo_Class const* _eo_class()
   {
      return(ECORE_PARENT_CLASS);
   }

private:
};
namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::ecore_parent >
{
   template <typename T>
   struct type
   {
   };
};


template<>
struct operation_description_class_size< ::ecore_parent >
{
   static const int value = 0;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<::ecore_parent>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   return 0;
}
template<>
struct extension_inheritance< ::ecore_parent>
{
   template <typename T>
   struct type
   {
      operator ::ecore_parent() const
      {
         return ::ecore_parent(eo_ref(static_cast<T const*>(this)->_eo_ptr()));
      }

   };
};

inline Eo_Class const* get_eo_class(tag<::ecore_parent>)
{
   return (ECORE_PARENT_CLASS);
}

} } }
#endif // EFL_GENERATED_ECORE_PARENT_HH

